// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from four_wheel_steering_msgs:msg/FourWheelSteering.idl
// generated code does not contain a copyright notice

#ifndef FOUR_WHEEL_STEERING_MSGS__MSG__DETAIL__FOUR_WHEEL_STEERING__STRUCT_H_
#define FOUR_WHEEL_STEERING_MSGS__MSG__DETAIL__FOUR_WHEEL_STEERING__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in msg/FourWheelSteering in the package four_wheel_steering_msgs.
/**
  * Driving command or odometry msg for a FourWheelSteering vehicle.
  *  $Id$
 */
typedef struct four_wheel_steering_msgs__msg__FourWheelSteering
{
  /// Assumes FourWheelSteering with front-wheel and rear-wheel steering. The left
  /// and right front wheels are generally at different angles. To simplify,
  /// the commanded angle corresponds to the yaw of a virtual wheel located at the
  /// center of the front or rear axle, like on a tricycle.  Positive yaw is to
  /// the left. (This is *not* the angle of the steering wheel inside the
  /// passenger compartment.)
  ///
  /// Zero steering angle velocity means change the steering angle as
  /// quickly as possible. Positive velocity indicates an absolute
  /// rate of change either left or right.
  ///
  /// position of the virtual angle (radians)
  float front_steering_angle;
  /// position of the virtual angle (radians)
  float rear_steering_angle;
  /// rate of change (radians/s)
  float front_steering_angle_velocity;
  /// rate of change (radians/s)
  float rear_steering_angle_velocity;
  /// Speed, acceleration and jerk (the 1st, 2nd and 3rd
  /// derivatives of position). All are measured at the vehicle's
  /// center of the rear axle.
  ///
  /// Speed is the scalar magnitude of the velocity vector.
  /// The speed value is the norm of the velocity component in x (longitudinal)
  /// and y (lateral) direction
  /// Direction is forward unless the sign is negative, indicating reverse.
  /// If the steering angle are equal to +/- pi/2, then the direction is left
  /// unless the sign is negative, indicating right.
  ///
  /// Zero acceleration means change speed as quickly as
  /// possible. Positive acceleration indicates an absolute
  /// magnitude; that includes deceleration.
  ///
  /// Zero jerk means change acceleration as quickly as possible. Positive
  /// jerk indicates an absolute rate of acceleration change in
  /// either direction (increasing or decreasing).
  ///
  /// forward speed (m/s)
  float speed;
  /// acceleration (m/s^2)
  float acceleration;
  /// jerk (m/s^3)
  float jerk;
} four_wheel_steering_msgs__msg__FourWheelSteering;

// Struct for a sequence of four_wheel_steering_msgs__msg__FourWheelSteering.
typedef struct four_wheel_steering_msgs__msg__FourWheelSteering__Sequence
{
  four_wheel_steering_msgs__msg__FourWheelSteering * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} four_wheel_steering_msgs__msg__FourWheelSteering__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // FOUR_WHEEL_STEERING_MSGS__MSG__DETAIL__FOUR_WHEEL_STEERING__STRUCT_H_
